##############################################################################
#
# Copyright (c) 2004,2008 Bjorn Tillenius
#
# This file is part of Grammatista.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
"""Creates a new database schema."""

import psycopg2

from grammatista.database.store import disconnect_database


def createDB():
    # Make sure that we're not connected to our test DB.
    disconnect_database()
    con = psycopg2.connect('dbname=grammatista_template')
    cur = con.cursor()
    cur.execute("ABORT;")
    cur.execute("DROP DATABASE IF EXISTS grammatista_dev")
    cur.execute(
        """CREATE DATABASE grammatista_dev
           WITH TEMPLATE grammatista_template ENCODING = 'UTF8'""")
    con.close()
