##############################################################################
#
# Copyright (c) 2008 Bjorn Tillenius
#
# This file is part of Grammatista.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from storm.store import Store
from storm.database import create_database

_database = create_database('postgres:///grammatista_dev')
_store = None

def get_database():
    global _database
    return _database

def disconnect_database():
    global _store
    if _store is None:
        return
    global _database
    _store.close()
    _store = None

def get_store():
    global _store
    if _store is None:
        database = get_database()
        _store = Store(database)
    return _store
