##############################################################################
#
# Copyright (c) 2008 Bjorn Tillenius
#
# This file is part of Grammatista.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
"""Classes that bind ReferenceSets together."""

from storm.base import Storm
from storm.properties import Int


class ExerciseDefinitionInflectionForm(Storm):
    """Links an ExerciseDefinition to an InflectionForm."""

    __storm_table__ = "ExerciseDefinitionInflectionForm"
    __storm_primary__ = ("exercise_definition_id", "inflection_form_id")

    exercise_definition_id = Int(name='exercise_definition')
    inflection_form_id = Int(name='inflection_form')


class InflectionFormInflectionFormObject(Storm):

    __storm_table__ = "InflectionFormInflectionFormObject"
    __storm_primary__ = ("inflection_form_id", "inflection_form_object_id")

    inflection_form_id = Int(name='inflection_form')
    inflection_form_object_id = Int(name='inflection_form_object')


class InflectionMorphProperty(Storm):

    __storm_table__ = "InflectionMorphProperty"
    __storm_primary__ = ("inflection_id", "inflection_form_object_id")

    inflection_id = Int(name='inflection')
    inflection_form_object_id = Int(name='inflection_form_object')


class InflectionOutputInflectionForm(Storm):

    __storm_table__ = "InflectionOutputInflectionForm"
    __storm_primary__ = ("inflection_id", "inflection_form_id")

    inflection_id = Int(name='inflection')
    inflection_form_id = Int(name='inflection_form')


class WordCategoryInflectionForm(Storm):

    __storm_table__ = "WordCategoryInflectionForm"
    __storm_primary__ = ("word_category_id", "inflection_form_id")

    word_category_id = Int(name="word_category")
    inflection_form_id = Int(name="inflection_form")


class WordCategoryMorphPropertyGroup(Storm):

    __storm_table__ = "WordCategoryMorphPropertyGroup"
    __storm_primary__ = ("word_category_id", "inflection_form_group_id")

    word_category_id = Int(name="word_category")
    inflection_form_group_id = Int(name="inflection_form_group")


class WordMorphProperty(Storm):

    __storm_table__ = "WordMorphProperty"
    __storm_primary__ = ("word_id", "inflection_form_object_id")

    word_id = Int(name='word')
    inflection_form_object_id = Int(name='inflection_form_object')


class WordWordList(Storm):

    __storm_table__ = "WordWordList"
    __storm_primary__ = ("word_id", "word_list_id")

    word_id = Int(name="word")
    word_list_id = Int(name="word_list")
